Claudiu Persoiu

Blog-ul lui Claudiu Persoiu


Finally finally in PHP 5.5

with one comment

The newest PHP version is almost ready. At the time I’m writing this blog PHP 5.5 is in RC 1.

As I was saying in my last blog, the feature list is available at: http://www.php.net/manual/en/migration55.new-features.php

The second feature, in terms of popularity, is “finally“: http://www.php.net/manual/en/language.exceptions.php

What’s the deal with “finally“?

It looks a little confusing, is looks like a block that’s getting executed after the “try/catch” finishes. But what is so new about it?

Let’s take a try/catch block:

PHP 5.x < 5.5:

// open resouce
$resource = new Resouce();
try {
   // do stuff with the resouce
   $resouce->doStuff();
} catch (Exception $e) {
   // log exception
   syslog(LOG_ERR, $e->getMessage());
}
// release resouce
unset($resouce);

PHP 5.5

// open resouce
$resource = new Resouce();
try {
   // do stuff with the resouce
   $resouce->doStuff();
} catch (Exception $e) {
   // log exception
   syslog(LOG_ERR, $e->getMessage());
} finally {
   // release resouce
   unset($resouce);
}

Up to this point there isn’t any reason for a new block. The exception was catched, it was logged and continues.

But let’s say there is a resource and we need to close it, and after that we need to throw an exception. One way this can be achieved is to release the resource in catch.

But there is still the “successful” case, and we need to release it in that case also.

// open resouce
$resource = new Resouce();
try {
   // do stuff with the resouce
   $resouce->doStuff();
} catch (Exception $e) {
   // release resouce
   unset($resource);
   // perpetuate exception
   throw $e;
}

Let’s complicate stuff even more, let’s say there are n exception types. It will result in n catch conditions, plus the successful case, and in all of these cases we need to free the resource. Not very efficient…

Another way is to store the exception in a variable and, after the resource is released, to throw the exception, if that is the case.

// variable to store the exception
$exception = false;

// open resouce
$resource = new Resouce();
try {
   // do stuff with the resouce
   $resouce->doStuff();
} catch (Exception $e) {
   $exception = $e;
}

// release resouce
unset($resource);

if($exception) {
   throw $exception;
}

This is one way it is done right now. It’s working but it’s not clear that we are only trying to release the resource and continue our lives in peace.

The PHP 5.5 way

In the php.net manual:

In PHP 5.5 and later, a finally block may also be specified after the catch blocks. Code within the finally block will always be executed after the tryand catch blocks, regardless of whether an exception has been thrown, and before normal execution resumes.

Each time the block is executed, regardless if it was successful or not, finally will get executed. So, for the next example:

try {
    echo 'Do stuff' . PHP_EOL;
    throw new Exception('testing');
} finally {
    echo 'inside finally' . PHP_EOL;
}

The output will be:

Do stuff
inside finally

Fatal error: Uncaught exception 'Exception' with message 'testing' in...

If we want to also catch the exception:

try {
    echo 'Do stuff' . PHP_EOL;
    throw new Exception('testing');
} catch (Exception $e) {
    echo 'do something with the exception' . PHP_EOL;
} finally {
    echo 'inside finally' . PHP_EOL;
}

The output will be:

Do stuff
do something with the exception
inside finally

And even if we take the particular case when we catch the exception and then throw it:

try {
    echo 'Do stuff' . PHP_EOL;
    throw new Exception('testing');
} catch (Exception $e) {
    echo 'do something with the exception' . PHP_EOL;
    throw $e;
} finally {
    echo 'inside finally' . PHP_EOL;
}

It seems we prevented the finally block from getting executed? Well, not exactly…

Do stuff
do something with the exception
inside finally

Fatal error: Uncaught exception 'Exception' with message 'testing' in...

In other words, the finally block gets executed each time, regardless of the result.

Written by Claudiu Persoiu

19 May 2013 at 7:34 PM

Posted in PHP

Tagged with , ,

One Response to 'Finally finally in PHP 5.5'

Subscribe to comments with RSS or TrackBack to 'Finally finally in PHP 5.5'.

  1. finally, like in java and python and probably other OO languages.

    razzvan

    20 May 2013 at 12:37 PM

Leave a Reply